Imports System.data
Imports System.Data.Sqlclient

Public Class Form1

    Private Sub btnProcuraClientePorNome_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProcuraClientePorNome.Click
        If txtProcuraClientePorNome.Text.Trim.Length > 1 Then

            ErrorProvider1.SetError(txtProcuraClientePorNome, "")
            Dim da As CadastroDataSetTableAdapters.ClientesTableAdapter = New CadastroDataSetTableAdapters.ClientesTableAdapter

            lstbClientes.DataSource = da.GetDataByNome("%" & txtProcuraClientePorNome.Text & "%")
            lstbClientes.DisplayMember = "nome"
            lstbClientes.ValueMember = "clienteID"
            lstbClientes.Refresh()
        Else
            ErrorProvider1.SetError(txtProcuraClientePorNome, "Informe o nome do cliente com no mnimo 2 caracteres...")
        End If

    End Sub
    Private Sub carregaClientes(ByVal clienteID As Integer)

        Dim strConn As String = My.Settings.CadastroConnectionString.ToString()
        Dim strSQL As String = "Select * from Clientes Where clienteID = " & clienteID
        Dim dr As SqlDataReader

        'define objeto connection e command
        Dim con As New SqlConnection(strConn)
        Dim cmd As New SqlCommand(strSQL, con)
        Try
            con.Open()

            dr = cmd.ExecuteReader

            If (dr.HasRows) Then
                dr.Read()

                ClienteIDTextBox.Text = dr("clienteID").ToString
                NomeTextBox.Text = dr("nome").ToString
                EnderecoTextBox.Text = dr("endereco").ToString
                CidadeTextBox.Text = dr("cidade").ToString
                EstadoTextBox.Text = dr("estado").ToString
                CepTextBox.Text = dr("cep").ToString
                TelefoneTextBox.Text = dr("telefone").ToString
                EmailTextBox.Text = dr("email").ToString
                sexoTextBox.Text() = dr("sexo").ToString
                NascimentoDateTimePicker.Text = dr("nascimento").ToString

            End If
        Catch ex As Exception
            MsgBox("Erro ao obter dados dos clientes. Erro : " & ex.Message)
        Finally
            con.Close()
        End Try

    End Sub
    Private Sub lstbClientes_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstbClientes.SelectedIndexChanged
        If (lstbClientes.SelectedValue.ToString() <> "System.Data.DataRowView") Then
            carregaClientes(CInt(Me.lstbClientes.SelectedValue))
        End If
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        calculaNumeroRegistros()
    End Sub
    Private Sub calculaNumeroRegistros()
        Dim strConn As String = My.Settings.CadastroConnectionString.ToString()
        Dim strSQL As String = "Select Count(*) From Clientes"

        'define objeto connection e command
        Dim con As New SqlConnection(strConn)
        Dim cmd As New SqlCommand(strSQL, con)

        con.Open()
        Try
            lblNumeroRegistros.Text = "Clientes Cadastrados: " & cmd.ExecuteScalar.ToString
        Catch ex As Exception
            MsgBox("Erro ao calcular numero de registros. Erro : " & ex.Message)
        Finally
            con.Close()
        End Try

    End Sub
    Private Sub btnIncluir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnIncluir.Click
        Dim msg As String = ""
        Dim sql As String = ""
        Dim strConn As String = My.Settings.CadastroConnectionString.ToString()

        If btnIncluir.Text = "Incluir" Then
            btnIncluir.Text = "Salvar"
            lstbClientes.Enabled = False
            limpaControles(Me)
            NomeTextBox.Focus()
        ElseIf btnIncluir.Text = "Salvar" Then
            If valida() Then
                sql = "INSERT INTO Clientes (nome, endereco, cidade, estado, cep, telefone, email, sexo, nascimento) VALUES('" _
                                            + NomeTextBox.Text + "','" _
                                            + EnderecoTextBox.Text + "','" _
                                            + CidadeTextBox.Text + "','" _
                                            + EstadoTextBox.Text + "','" _
                                            + CepTextBox.Text + "','" _
                                            + TelefoneTextBox.Text + "','" _
                                            + EmailTextBox.Text + "','" _
                                            + sexoTextBox.Text + "','" _
                                            + NascimentoDateTimePicker.Text + "')"

                Dim con As New SqlConnection(strConn)
                Dim cmd As New SqlCommand(sql, con)
                Try
                    con.Open()
                    cmd.ExecuteNonQuery()
                    MsgBox("Cliente incluido com sucesso.")
                    btnIncluir.Text = "Incluir"
                Catch ex As Exception
                    MsgBox(ex.Message)
                End Try
                lstbClientes.Enabled = True
            Else
                MsgBox("Dados incompletos.")
                lstbClientes.Enabled = True
                btnIncluir.Text = "Incluir"
            End If
        End If
    End Sub
    Private Sub btnAlterar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAlterar.Click

        If lstbClientes.SelectedIndex <> -1 Then
            Dim sql As String = ""
            Dim strConn As String = My.Settings.CadastroConnectionString.ToString()
            If valida() Then
                sql = "UPDATE Clientes SET nome       = '" + NomeTextBox.Text _
                                      + "',endereco   = '" + EnderecoTextBox.Text _
                                      + "',cidade     ='" + CidadeTextBox.Text _
                                      + "',estado     = '" + EstadoTextBox.Text _
                                      + "',cep        = '" + CepTextBox.Text _
                                      + "',telefone   = '" + TelefoneTextBox.Text _
                                      + "',email      ='" + EmailTextBox.Text _
                                      + "',sexo       = '" + sexoTextBox.Text _
                                      + "',nascimento = '" + NascimentoDateTimePicker.Text + "'" _
                                      + " WHERE clienteID = " + lstbClientes.SelectedValue.ToString

                'define objeto connection e command
                Dim con As New SqlConnection(strConn)
                Dim cmd As New SqlCommand(sql, con)
                Try
                    con.Open()
                    cmd.ExecuteNonQuery()
                    MsgBox("Cliente alterado com sucesso.")
                Catch ex As Exception
                    MsgBox(ex.Message)
                End Try
            Else
                MsgBox("Dados incompletos")
            End If
        Else
            MsgBox("Selecione um cliente para alterar.")
        End If
    End Sub

    Private Sub btnExcluir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExcluir.Click
        If lstbClientes.SelectedIndex <> -1 Then
            Dim sql As String = ""
            Dim strConn As String = My.Settings.CadastroConnectionString.ToString()

            If MsgBox("Confirma a excluso do cliente de codigo igual a " + lstbClientes.SelectedValue.ToString, MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then

                sql = "DELETE FROM Clientes WHERE clienteID = " + lstbClientes.SelectedValue

                'define objeto connection e command
                Dim con As New SqlConnection(strConn)
                Dim cmd As New SqlCommand(sql, con)
                Try
                    con.Open()
                    cmd.ExecuteNonQuery()
                    MsgBox("Cliente excludo com sucesso.")
                    btnIncluir.Text = "Excluir"
                Catch ex As Exception
                    MsgBox("No foi possvel excluir o cliente." + vbCrLf + ex.Message)
                End Try
            End If
        Else
            MsgBox("Selecione um cliente para excluir.")
        End If
    End Sub
    Private Sub limpaControles(ByVal C As Control)

        Dim Ctrl As Control        'Declara um objeto control generico
        Dim MyCheckBox As CheckBox 'Declara um controle CheckBox

        For Each Ctrl In C.Controls
            Select Case TypeName(Ctrl)
                Case "ListBox"
                    Ctrl.Text = ""
                Case "TextBox"
                    Ctrl.Text = ""
                Case "MaskedTextBox"
                    Ctrl.Text = ""
                Case "CheckBox"
                    MyCheckBox = CType(Ctrl, CheckBox)
                    MyCheckBox.Checked = False
                Case Else
                    If Ctrl.Controls.Count > 0 Then 'Verificao para container
                        limpaControles(Ctrl)        'Faz chamada recursiva para os controles do container
                    End If
            End Select
        Next Ctrl
    End Sub

    'Private Sub btnSalvar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Dim msg As String = ""
    '    Dim sql As String = ""
    '    Dim strConn As String = My.Settings.CadastroConnectionString.ToString()

    '    sql = "INSERT INTO Clientes (nome, endereco, cidade, estado, cep, telefone, email, sexo, nascimento) VALUES ('" + NomeTextBox.Text + "','" + EnderecoTextBox.Text + "','" + CidadeTextBox.Text + "','" + EstadoTextBox.Text + "','" + CepTextBox.Text + "','" + TelefoneTextBox.Text + "','" + EmailTextBox.Text + "','" + sexoTextBox.Text + "'," + NascimentoDateTimePicker.Text + ")"
    '    'define objeto connection e command
    '    Dim con As New SqlConnection(strConn)
    '    Dim cmd As New SqlCommand(sql, con)
    '    Try
    '        con.Open()
    '        cmd.ExecuteNonQuery()
    '        msg = "Cliente incluido com sucesso."
    '        btnIncluir.Text = "Incluir"
    '    Catch ex As Exception
    '        MsgBox(ex.Message)
    '    End Try

    'End Sub
    Private Function valida() As Boolean
        'verifica se algumas informaes foram fornecidas
        If NomeTextBox.Text = String.Empty Or EnderecoTextBox.Text = String.Empty Or CidadeTextBox.Text = String.Empty Or EstadoTextBox.Text = String.Empty Or CepTextBox.Text = String.Empty Then
            Return False
        Else
            Return True
        End If
    End Function

    Private Sub btnSair_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSair.Click
        If MsgBox("Deseja encerrar a aplicao ? ", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            Me.Close()
        End If
    End Sub
End Class
